<?php

namespace AfhcFacilityFinder\SForce;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'sObject' => '\\AfhcFacilityFinder\\SForce\\StructType\\SObject',
            'address' => '\\AfhcFacilityFinder\\SForce\\StructType\\Address',
            'location' => '\\AfhcFacilityFinder\\SForce\\StructType\\Location',
            'QueryResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\QueryResult',
            'SearchResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\SearchResult',
            'SearchRecord' => '\\AfhcFacilityFinder\\SForce\\StructType\\SearchRecord',
            'SearchRecordMetadata' => '\\AfhcFacilityFinder\\SForce\\StructType\\SearchRecordMetadata',
            'SearchSnippet' => '\\AfhcFacilityFinder\\SForce\\StructType\\SearchSnippet',
            'SearchResultsMetadata' => '\\AfhcFacilityFinder\\SForce\\StructType\\SearchResultsMetadata',
            'LabelsSearchMetadata' => '\\AfhcFacilityFinder\\SForce\\StructType\\LabelsSearchMetadata',
            'EntitySearchMetadata' => '\\AfhcFacilityFinder\\SForce\\StructType\\EntitySearchMetadata',
            'FieldLevelSearchMetadata' => '\\AfhcFacilityFinder\\SForce\\StructType\\FieldLevelSearchMetadata',
            'EntitySpellCorrectionMetadata' => '\\AfhcFacilityFinder\\SForce\\StructType\\EntitySpellCorrectionMetadata',
            'EntitySearchPromotionMetadata' => '\\AfhcFacilityFinder\\SForce\\StructType\\EntitySearchPromotionMetadata',
            'EntityIntentQueryMetadata' => '\\AfhcFacilityFinder\\SForce\\StructType\\EntityIntentQueryMetadata',
            'EntityErrorMetadata' => '\\AfhcFacilityFinder\\SForce\\StructType\\EntityErrorMetadata',
            'RelationshipReferenceTo' => '\\AfhcFacilityFinder\\SForce\\StructType\\RelationshipReferenceTo',
            'RecordTypesSupported' => '\\AfhcFacilityFinder\\SForce\\StructType\\RecordTypesSupported',
            'JunctionIdListNames' => '\\AfhcFacilityFinder\\SForce\\StructType\\JunctionIdListNames',
            'SearchLayoutButtonsDisplayed' => '\\AfhcFacilityFinder\\SForce\\StructType\\SearchLayoutButtonsDisplayed',
            'SearchLayoutButton' => '\\AfhcFacilityFinder\\SForce\\StructType\\SearchLayoutButton',
            'SearchLayoutFieldsDisplayed' => '\\AfhcFacilityFinder\\SForce\\StructType\\SearchLayoutFieldsDisplayed',
            'SearchLayoutField' => '\\AfhcFacilityFinder\\SForce\\StructType\\SearchLayoutField',
            'NameValuePair' => '\\AfhcFacilityFinder\\SForce\\StructType\\NameValuePair',
            'NameObjectValuePair' => '\\AfhcFacilityFinder\\SForce\\StructType\\NameObjectValuePair',
            'SimpleNameObjectValuePair' => '\\AfhcFacilityFinder\\SForce\\StructType\\SimpleNameObjectValuePair',
            'GetUpdatedResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\GetUpdatedResult',
            'GetDeletedResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\GetDeletedResult',
            'DeletedRecord' => '\\AfhcFacilityFinder\\SForce\\StructType\\DeletedRecord',
            'GetServerTimestampResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\GetServerTimestampResult',
            'InvalidateSessionsResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\InvalidateSessionsResult',
            'SetPasswordResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\SetPasswordResult',
            'ChangeOwnPasswordResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\ChangeOwnPasswordResult',
            'ResetPasswordResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\ResetPasswordResult',
            'GetUserInfoResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\GetUserInfoResult',
            'LoginResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\LoginResult',
            'ExtendedErrorDetails' => '\\AfhcFacilityFinder\\SForce\\StructType\\ExtendedErrorDetails',
            'Error' => '\\AfhcFacilityFinder\\SForce\\StructType\\Error',
            'SendEmailError' => '\\AfhcFacilityFinder\\SForce\\StructType\\SendEmailError',
            'SaveResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\SaveResult',
            'RenderEmailTemplateError' => '\\AfhcFacilityFinder\\SForce\\StructType\\RenderEmailTemplateError',
            'UpsertResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\UpsertResult',
            'PerformQuickActionResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\PerformQuickActionResult',
            'QuickActionTemplateResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\QuickActionTemplateResult',
            'MergeRequest' => '\\AfhcFacilityFinder\\SForce\\StructType\\MergeRequest',
            'MergeResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\MergeResult',
            'ProcessRequest' => '\\AfhcFacilityFinder\\SForce\\StructType\\ProcessRequest',
            'ProcessSubmitRequest' => '\\AfhcFacilityFinder\\SForce\\StructType\\ProcessSubmitRequest',
            'ProcessWorkitemRequest' => '\\AfhcFacilityFinder\\SForce\\StructType\\ProcessWorkitemRequest',
            'PerformQuickActionRequest' => '\\AfhcFacilityFinder\\SForce\\StructType\\PerformQuickActionRequest',
            'DescribeAvailableQuickActionResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeAvailableQuickActionResult',
            'DescribeQuickActionResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeQuickActionResult',
            'DescribeQuickActionDefaultValue' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeQuickActionDefaultValue',
            'DescribeVisualForceResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeVisualForceResult',
            'ProcessResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\ProcessResult',
            'DeleteResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DeleteResult',
            'UndeleteResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\UndeleteResult',
            'DeleteByExampleResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DeleteByExampleResult',
            'EmptyRecycleBinResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\EmptyRecycleBinResult',
            'LeadConvert' => '\\AfhcFacilityFinder\\SForce\\StructType\\LeadConvert',
            'LeadConvertResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\LeadConvertResult',
            'DescribeSObjectResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSObjectResult',
            'DescribeGlobalSObjectResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeGlobalSObjectResult',
            'ChildRelationship' => '\\AfhcFacilityFinder\\SForce\\StructType\\ChildRelationship',
            'DescribeGlobalResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeGlobalResult',
            'DescribeGlobalTheme' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeGlobalTheme',
            'ScopeInfo' => '\\AfhcFacilityFinder\\SForce\\StructType\\ScopeInfo',
            'StringList' => '\\AfhcFacilityFinder\\SForce\\StructType\\StringList',
            'ChangeEventHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\ChangeEventHeader',
            'FilteredLookupInfo' => '\\AfhcFacilityFinder\\SForce\\StructType\\FilteredLookupInfo',
            'Field' => '\\AfhcFacilityFinder\\SForce\\StructType\\Field',
            'PicklistEntry' => '\\AfhcFacilityFinder\\SForce\\StructType\\PicklistEntry',
            'DescribeDataCategoryGroupResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeDataCategoryGroupResult',
            'DescribeDataCategoryGroupStructureResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeDataCategoryGroupStructureResult',
            'DataCategoryGroupSobjectTypePair' => '\\AfhcFacilityFinder\\SForce\\StructType\\DataCategoryGroupSobjectTypePair',
            'DataCategory' => '\\AfhcFacilityFinder\\SForce\\StructType\\DataCategory',
            'DescribeDataCategoryMappingResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeDataCategoryMappingResult',
            'KnowledgeSettings' => '\\AfhcFacilityFinder\\SForce\\StructType\\KnowledgeSettings',
            'KnowledgeLanguageItem' => '\\AfhcFacilityFinder\\SForce\\StructType\\KnowledgeLanguageItem',
            'FieldDiff' => '\\AfhcFacilityFinder\\SForce\\StructType\\FieldDiff',
            'AdditionalInformationMap' => '\\AfhcFacilityFinder\\SForce\\StructType\\AdditionalInformationMap',
            'MatchRecord' => '\\AfhcFacilityFinder\\SForce\\StructType\\MatchRecord',
            'MatchResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\MatchResult',
            'DuplicateResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DuplicateResult',
            'DuplicateError' => '\\AfhcFacilityFinder\\SForce\\StructType\\DuplicateError',
            'DescribeNounResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeNounResult',
            'NameCaseValue' => '\\AfhcFacilityFinder\\SForce\\StructType\\NameCaseValue',
            'findDuplicates' => '\\AfhcFacilityFinder\\SForce\\StructType\\FindDuplicates',
            'findDuplicatesByIds' => '\\AfhcFacilityFinder\\SForce\\StructType\\FindDuplicatesByIds',
            'findDuplicatesByIdsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\FindDuplicatesByIdsResponse',
            'findDuplicatesResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\FindDuplicatesResponse',
            'FindDuplicatesResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\FindDuplicatesResult',
            'DescribeAppMenuResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeAppMenuResult',
            'DescribeAppMenuItem' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeAppMenuItem',
            'DescribeThemeResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeThemeResult',
            'DescribeThemeItem' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeThemeItem',
            'DescribeSoftphoneLayoutResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSoftphoneLayoutResult',
            'DescribeSoftphoneLayoutCallType' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSoftphoneLayoutCallType',
            'DescribeSoftphoneScreenPopOption' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSoftphoneScreenPopOption',
            'DescribeSoftphoneLayoutInfoField' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSoftphoneLayoutInfoField',
            'DescribeSoftphoneLayoutSection' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSoftphoneLayoutSection',
            'DescribeSoftphoneLayoutItem' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSoftphoneLayoutItem',
            'DescribeCompactLayoutsResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeCompactLayoutsResult',
            'DescribeCompactLayout' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeCompactLayout',
            'RecordTypeCompactLayoutMapping' => '\\AfhcFacilityFinder\\SForce\\StructType\\RecordTypeCompactLayoutMapping',
            'DescribePathAssistantsResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribePathAssistantsResult',
            'DescribePathAssistant' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribePathAssistant',
            'DescribePathAssistantStep' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribePathAssistantStep',
            'DescribePathAssistantField' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribePathAssistantField',
            'DescribeAnimationRule' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeAnimationRule',
            'DescribeApprovalLayoutResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeApprovalLayoutResult',
            'DescribeApprovalLayout' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeApprovalLayout',
            'DescribeLayoutResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeLayoutResult',
            'DescribeLayout' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeLayout',
            'DescribeQuickActionListResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeQuickActionListResult',
            'DescribeQuickActionListItemResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeQuickActionListItemResult',
            'DescribeLayoutFeedView' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeLayoutFeedView',
            'DescribeLayoutFeedFilter' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeLayoutFeedFilter',
            'DescribeLayoutSaveOption' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeLayoutSaveOption',
            'DescribeLayoutSection' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeLayoutSection',
            'DescribeLayoutButtonSection' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeLayoutButtonSection',
            'DescribeLayoutRow' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeLayoutRow',
            'DescribeLayoutItem' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeLayoutItem',
            'DescribeLayoutButton' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeLayoutButton',
            'DescribeLayoutComponent' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeLayoutComponent',
            'FieldComponent' => '\\AfhcFacilityFinder\\SForce\\StructType\\FieldComponent',
            'FieldLayoutComponent' => '\\AfhcFacilityFinder\\SForce\\StructType\\FieldLayoutComponent',
            'VisualforcePage' => '\\AfhcFacilityFinder\\SForce\\StructType\\VisualforcePage',
            'Canvas' => '\\AfhcFacilityFinder\\SForce\\StructType\\Canvas',
            'ReportChartComponent' => '\\AfhcFacilityFinder\\SForce\\StructType\\ReportChartComponent',
            'AnalyticsCloudComponent' => '\\AfhcFacilityFinder\\SForce\\StructType\\AnalyticsCloudComponent',
            'CustomLinkComponent' => '\\AfhcFacilityFinder\\SForce\\StructType\\CustomLinkComponent',
            'NamedLayoutInfo' => '\\AfhcFacilityFinder\\SForce\\StructType\\NamedLayoutInfo',
            'RecordTypeInfo' => '\\AfhcFacilityFinder\\SForce\\StructType\\RecordTypeInfo',
            'RecordTypeMapping' => '\\AfhcFacilityFinder\\SForce\\StructType\\RecordTypeMapping',
            'PicklistForRecordType' => '\\AfhcFacilityFinder\\SForce\\StructType\\PicklistForRecordType',
            'RelatedContent' => '\\AfhcFacilityFinder\\SForce\\StructType\\RelatedContent',
            'DescribeRelatedContentItem' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeRelatedContentItem',
            'RelatedList' => '\\AfhcFacilityFinder\\SForce\\StructType\\RelatedList',
            'RelatedListColumn' => '\\AfhcFacilityFinder\\SForce\\StructType\\RelatedListColumn',
            'RelatedListSort' => '\\AfhcFacilityFinder\\SForce\\StructType\\RelatedListSort',
            'EmailFileAttachment' => '\\AfhcFacilityFinder\\SForce\\StructType\\EmailFileAttachment',
            'Email' => '\\AfhcFacilityFinder\\SForce\\StructType\\Email',
            'MassEmailMessage' => '\\AfhcFacilityFinder\\SForce\\StructType\\MassEmailMessage',
            'SingleEmailMessage' => '\\AfhcFacilityFinder\\SForce\\StructType\\SingleEmailMessage',
            'SendEmailResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\SendEmailResult',
            'ListViewColumn' => '\\AfhcFacilityFinder\\SForce\\StructType\\ListViewColumn',
            'ListViewOrderBy' => '\\AfhcFacilityFinder\\SForce\\StructType\\ListViewOrderBy',
            'DescribeSoqlListView' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSoqlListView',
            'DescribeSoqlListViewsRequest' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSoqlListViewsRequest',
            'DescribeSoqlListViewParams' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSoqlListViewParams',
            'DescribeSoqlListViewResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSoqlListViewResult',
            'ExecuteListViewRequest' => '\\AfhcFacilityFinder\\SForce\\StructType\\ExecuteListViewRequest',
            'ExecuteListViewResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\ExecuteListViewResult',
            'ListViewRecord' => '\\AfhcFacilityFinder\\SForce\\StructType\\ListViewRecord',
            'ListViewRecordColumn' => '\\AfhcFacilityFinder\\SForce\\StructType\\ListViewRecordColumn',
            'SoqlWhereCondition' => '\\AfhcFacilityFinder\\SForce\\StructType\\SoqlWhereCondition',
            'SoqlCondition' => '\\AfhcFacilityFinder\\SForce\\StructType\\SoqlCondition',
            'SoqlNotCondition' => '\\AfhcFacilityFinder\\SForce\\StructType\\SoqlNotCondition',
            'SoqlConditionGroup' => '\\AfhcFacilityFinder\\SForce\\StructType\\SoqlConditionGroup',
            'SoqlSubQueryCondition' => '\\AfhcFacilityFinder\\SForce\\StructType\\SoqlSubQueryCondition',
            'DescribeSearchLayoutResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSearchLayoutResult',
            'DescribeColumn' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeColumn',
            'DescribeSearchScopeOrderResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSearchScopeOrderResult',
            'DescribeSearchableEntityResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSearchableEntityResult',
            'DescribeTabSetResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeTabSetResult',
            'DescribeTab' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeTab',
            'DescribeColor' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeColor',
            'DescribeIcon' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeIcon',
            'ActionOverride' => '\\AfhcFacilityFinder\\SForce\\StructType\\ActionOverride',
            'login' => '\\AfhcFacilityFinder\\SForce\\StructType\\Login',
            'loginResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\LoginResponse',
            'describeSObject' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSObject',
            'describeSObjectResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSObjectResponse',
            'describeSObjects' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSObjects',
            'describeSObjectsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSObjectsResponse',
            'describeGlobal' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeGlobal',
            'describeGlobalResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeGlobalResponse',
            'describeGlobalTheme' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeGlobalTheme_1',
            'describeGlobalThemeResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeGlobalThemeResponse',
            'describeTheme' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeTheme',
            'describeThemeResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeThemeResponse',
            'describeDataCategoryGroups' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeDataCategoryGroups',
            'describeDataCategoryGroupsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeDataCategoryGroupsResponse',
            'describeDataCategoryGroupStructures' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeDataCategoryGroupStructures',
            'describeDataCategoryGroupStructuresResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeDataCategoryGroupStructuresResponse',
            'describeDataCategoryMappings' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeDataCategoryMappings',
            'describeDataCategoryMappingsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeDataCategoryMappingsResponse',
            'describeKnowledgeSettings' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeKnowledgeSettings',
            'describeKnowledgeSettingsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeKnowledgeSettingsResponse',
            'describeAppMenu' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeAppMenu',
            'describeAppMenuResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeAppMenuResponse',
            'describeLayout' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeLayout_1',
            'describeLayoutResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeLayoutResponse',
            'describeCompactLayouts' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeCompactLayouts',
            'describeCompactLayoutsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeCompactLayoutsResponse',
            'describePrimaryCompactLayouts' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribePrimaryCompactLayouts',
            'describePrimaryCompactLayoutsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribePrimaryCompactLayoutsResponse',
            'describePathAssistants' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribePathAssistants',
            'describePathAssistantsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribePathAssistantsResponse',
            'describeApprovalLayout' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeApprovalLayout_1',
            'describeApprovalLayoutResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeApprovalLayoutResponse',
            'describeSoftphoneLayout' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSoftphoneLayout',
            'describeSoftphoneLayoutResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSoftphoneLayoutResponse',
            'describeSoqlListViews' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSoqlListViews',
            'describeSoqlListViewsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSoqlListViewsResponse',
            'executeListView' => '\\AfhcFacilityFinder\\SForce\\StructType\\ExecuteListView',
            'executeListViewResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\ExecuteListViewResponse',
            'describeSObjectListViews' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSObjectListViews',
            'describeSObjectListViewsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSObjectListViewsResponse',
            'describeSearchLayouts' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSearchLayouts',
            'describeSearchLayoutsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSearchLayoutsResponse',
            'describeSearchScopeOrder' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSearchScopeOrder',
            'describeSearchScopeOrderResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSearchScopeOrderResponse',
            'describeSearchableEntities' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSearchableEntities',
            'describeSearchableEntitiesResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeSearchableEntitiesResponse',
            'describeTabs' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeTabs',
            'describeTabsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeTabsResponse',
            'describeAllTabs' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeAllTabs',
            'describeAllTabsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeAllTabsResponse',
            'describeNouns' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeNouns',
            'describeNounsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeNounsResponse',
            'create' => '\\AfhcFacilityFinder\\SForce\\StructType\\Create',
            'createResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\CreateResponse',
            'sendEmail' => '\\AfhcFacilityFinder\\SForce\\StructType\\SendEmail',
            'sendEmailResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\SendEmailResponse',
            'RenderEmailTemplateRequest' => '\\AfhcFacilityFinder\\SForce\\StructType\\RenderEmailTemplateRequest',
            'RenderEmailTemplateBodyResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\RenderEmailTemplateBodyResult',
            'RenderEmailTemplateResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\RenderEmailTemplateResult',
            'renderEmailTemplate' => '\\AfhcFacilityFinder\\SForce\\StructType\\RenderEmailTemplate',
            'renderEmailTemplateResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\RenderEmailTemplateResponse',
            'RenderStoredEmailTemplateRequest' => '\\AfhcFacilityFinder\\SForce\\StructType\\RenderStoredEmailTemplateRequest',
            'RenderStoredEmailTemplateResult' => '\\AfhcFacilityFinder\\SForce\\StructType\\RenderStoredEmailTemplateResult',
            'renderStoredEmailTemplate' => '\\AfhcFacilityFinder\\SForce\\StructType\\RenderStoredEmailTemplate',
            'renderStoredEmailTemplateResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\RenderStoredEmailTemplateResponse',
            'sendEmailMessage' => '\\AfhcFacilityFinder\\SForce\\StructType\\SendEmailMessage',
            'sendEmailMessageResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\SendEmailMessageResponse',
            'update' => '\\AfhcFacilityFinder\\SForce\\StructType\\Update',
            'updateResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\UpdateResponse',
            'upsert' => '\\AfhcFacilityFinder\\SForce\\StructType\\Upsert',
            'upsertResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\UpsertResponse',
            'merge' => '\\AfhcFacilityFinder\\SForce\\StructType\\Merge',
            'mergeResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\MergeResponse',
            'delete' => '\\AfhcFacilityFinder\\SForce\\StructType\\Delete',
            'deleteResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DeleteResponse',
            'deleteByExample' => '\\AfhcFacilityFinder\\SForce\\StructType\\DeleteByExample',
            'deleteByExampleResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DeleteByExampleResponse',
            'undelete' => '\\AfhcFacilityFinder\\SForce\\StructType\\Undelete',
            'undeleteResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\UndeleteResponse',
            'emptyRecycleBin' => '\\AfhcFacilityFinder\\SForce\\StructType\\EmptyRecycleBin',
            'emptyRecycleBinResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\EmptyRecycleBinResponse',
            'process' => '\\AfhcFacilityFinder\\SForce\\StructType\\Process',
            'processResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\ProcessResponse',
            'performQuickActions' => '\\AfhcFacilityFinder\\SForce\\StructType\\PerformQuickActions',
            'performQuickActionsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\PerformQuickActionsResponse',
            'retrieveMassQuickActionTemplates' => '\\AfhcFacilityFinder\\SForce\\StructType\\RetrieveMassQuickActionTemplates',
            'retrieveMassQuickActionTemplatesResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\RetrieveMassQuickActionTemplatesResponse',
            'retrieveQuickActionTemplates' => '\\AfhcFacilityFinder\\SForce\\StructType\\RetrieveQuickActionTemplates',
            'retrieveQuickActionTemplatesResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\RetrieveQuickActionTemplatesResponse',
            'describeQuickActions' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeQuickActions',
            'describeQuickActionsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeQuickActionsResponse',
            'describeQuickActionsForRecordType' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeQuickActionsForRecordType',
            'describeQuickActionsForRecordTypeResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeQuickActionsForRecordTypeResponse',
            'describeAvailableQuickActions' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeAvailableQuickActions',
            'describeAvailableQuickActionsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeAvailableQuickActionsResponse',
            'describeVisualForce' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeVisualForce',
            'describeVisualForceResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\DescribeVisualForceResponse',
            'retrieve' => '\\AfhcFacilityFinder\\SForce\\StructType\\Retrieve',
            'retrieveResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\RetrieveResponse',
            'convertLead' => '\\AfhcFacilityFinder\\SForce\\StructType\\ConvertLead',
            'convertLeadResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\ConvertLeadResponse',
            'getUpdated' => '\\AfhcFacilityFinder\\SForce\\StructType\\GetUpdated',
            'getUpdatedResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\GetUpdatedResponse',
            'getDeleted' => '\\AfhcFacilityFinder\\SForce\\StructType\\GetDeleted',
            'getDeletedResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\GetDeletedResponse',
            'logout' => '\\AfhcFacilityFinder\\SForce\\StructType\\Logout',
            'logoutResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\LogoutResponse',
            'invalidateSessions' => '\\AfhcFacilityFinder\\SForce\\StructType\\InvalidateSessions',
            'invalidateSessionsResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\InvalidateSessionsResponse',
            'query' => '\\AfhcFacilityFinder\\SForce\\StructType\\Query',
            'queryResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\QueryResponse',
            'queryAll' => '\\AfhcFacilityFinder\\SForce\\StructType\\QueryAll',
            'queryAllResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\QueryAllResponse',
            'queryMore' => '\\AfhcFacilityFinder\\SForce\\StructType\\QueryMore',
            'queryMoreResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\QueryMoreResponse',
            'search' => '\\AfhcFacilityFinder\\SForce\\StructType\\Search',
            'searchResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\SearchResponse',
            'getServerTimestamp' => '\\AfhcFacilityFinder\\SForce\\StructType\\GetServerTimestamp',
            'getServerTimestampResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\GetServerTimestampResponse',
            'setPassword' => '\\AfhcFacilityFinder\\SForce\\StructType\\SetPassword',
            'setPasswordResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\SetPasswordResponse',
            'changeOwnPassword' => '\\AfhcFacilityFinder\\SForce\\StructType\\ChangeOwnPassword',
            'changeOwnPasswordResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\ChangeOwnPasswordResponse',
            'resetPassword' => '\\AfhcFacilityFinder\\SForce\\StructType\\ResetPassword',
            'resetPasswordResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\ResetPasswordResponse',
            'getUserInfo' => '\\AfhcFacilityFinder\\SForce\\StructType\\GetUserInfo',
            'getUserInfoResponse' => '\\AfhcFacilityFinder\\SForce\\StructType\\GetUserInfoResponse',
            'SessionHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\SessionHeader',
            'LoginScopeHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\LoginScopeHeader',
            'CallOptions' => '\\AfhcFacilityFinder\\SForce\\StructType\\CallOptions',
            'QueryOptions' => '\\AfhcFacilityFinder\\SForce\\StructType\\QueryOptions',
            'DebuggingHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\DebuggingHeader',
            'LogInfo' => '\\AfhcFacilityFinder\\SForce\\StructType\\LogInfo',
            'DebuggingInfo' => '\\AfhcFacilityFinder\\SForce\\StructType\\DebuggingInfo',
            'PackageVersion' => '\\AfhcFacilityFinder\\SForce\\StructType\\PackageVersion',
            'PackageVersionHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\PackageVersionHeader',
            'AllowFieldTruncationHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\AllowFieldTruncationHeader',
            'DisableFeedTrackingHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\DisableFeedTrackingHeader',
            'StreamingEnabledHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\StreamingEnabledHeader',
            'AllOrNoneHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\AllOrNoneHeader',
            'CurrencyConversionHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\CurrencyConversionHeader',
            'DuplicateRuleHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\DuplicateRuleHeader',
            'LimitInfo' => '\\AfhcFacilityFinder\\SForce\\StructType\\LimitInfo',
            'LimitInfoHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\LimitInfoHeader',
            'MruHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\MruHeader',
            'EmailHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\EmailHeader',
            'AssignmentRuleHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\AssignmentRuleHeader',
            'UserTerritoryDeleteHeader' => '\\AfhcFacilityFinder\\SForce\\StructType\\UserTerritoryDeleteHeader',
            'LocaleOptions' => '\\AfhcFacilityFinder\\SForce\\StructType\\LocaleOptions',
            'OwnerChangeOption' => '\\AfhcFacilityFinder\\SForce\\StructType\\OwnerChangeOption',
            'OwnerChangeOptions' => '\\AfhcFacilityFinder\\SForce\\StructType\\OwnerChangeOptions',
            'ApiFault' => '\\AfhcFacilityFinder\\SForce\\StructType\\ApiFault',
            'ApiQueryFault' => '\\AfhcFacilityFinder\\SForce\\StructType\\ApiQueryFault',
            'LoginFault' => '\\AfhcFacilityFinder\\SForce\\StructType\\LoginFault',
            'InvalidQueryLocatorFault' => '\\AfhcFacilityFinder\\SForce\\StructType\\InvalidQueryLocatorFault',
            'InvalidNewPasswordFault' => '\\AfhcFacilityFinder\\SForce\\StructType\\InvalidNewPasswordFault',
            'InvalidOldPasswordFault' => '\\AfhcFacilityFinder\\SForce\\StructType\\InvalidOldPasswordFault',
            'InvalidIdFault' => '\\AfhcFacilityFinder\\SForce\\StructType\\InvalidIdFault',
            'UnexpectedErrorFault' => '\\AfhcFacilityFinder\\SForce\\StructType\\UnexpectedErrorFault',
            'InvalidFieldFault' => '\\AfhcFacilityFinder\\SForce\\StructType\\InvalidFieldFault',
            'InvalidSObjectFault' => '\\AfhcFacilityFinder\\SForce\\StructType\\InvalidSObjectFault',
            'MalformedQueryFault' => '\\AfhcFacilityFinder\\SForce\\StructType\\MalformedQueryFault',
            'MalformedSearchFault' => '\\AfhcFacilityFinder\\SForce\\StructType\\MalformedSearchFault',
        );
    }
}
