<?php

namespace AfhcFacilityFinder\SForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DescribeLayoutFeedFilter StructType
 * @subpackage Structs
 */
class DescribeLayoutFeedFilter extends AbstractStructBase
{
    /**
     * The label
     * @var string
     */
    public $label;
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * The type
     * @var string
     */
    public $type;
    /**
     * Constructor method for DescribeLayoutFeedFilter
     * @uses DescribeLayoutFeedFilter::setLabel()
     * @uses DescribeLayoutFeedFilter::setName()
     * @uses DescribeLayoutFeedFilter::setType()
     * @param string $label
     * @param string $name
     * @param string $type
     */
    public function __construct($label = null, $name = null, $type = null)
    {
        $this
            ->setLabel($label)
            ->setName($name)
            ->setType($type);
    }
    /**
     * Get label value
     * @return string|null
     */
    public function getLabel()
    {
        return $this->label;
    }
    /**
     * Set label value
     * @param string $label
     * @return \AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedFilter
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($label, true), gettype($label)), __LINE__);
        }
        $this->label = $label;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedFilter
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @uses \AfhcFacilityFinder\SForce\EnumType\FeedLayoutFilterType::valueIsValid()
     * @uses \AfhcFacilityFinder\SForce\EnumType\FeedLayoutFilterType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedFilter
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\AfhcFacilityFinder\SForce\EnumType\FeedLayoutFilterType::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \AfhcFacilityFinder\SForce\EnumType\FeedLayoutFilterType', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \AfhcFacilityFinder\SForce\EnumType\FeedLayoutFilterType::getValidValues())), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
}
