<?php

namespace AfhcFacilityFinder\SForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DescribeLayoutFeedView StructType
 * @subpackage Structs
 */
class DescribeLayoutFeedView extends AbstractStructBase
{
    /**
     * The feedFilters
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedFilter[]
     */
    public $feedFilters;
    /**
     * Constructor method for DescribeLayoutFeedView
     * @uses DescribeLayoutFeedView::setFeedFilters()
     * @param \AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedFilter[] $feedFilters
     */
    public function __construct(array $feedFilters = array())
    {
        $this
            ->setFeedFilters($feedFilters);
    }
    /**
     * Get feedFilters value
     * @return \AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedFilter[]|null
     */
    public function getFeedFilters()
    {
        return $this->feedFilters;
    }
    /**
     * This method is responsible for validating the values passed to the setFeedFilters method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFeedFilters method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFeedFiltersForArrayConstraintsFromSetFeedFilters(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $describeLayoutFeedViewFeedFiltersItem) {
            // validation for constraint: itemType
            if (!$describeLayoutFeedViewFeedFiltersItem instanceof \AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedFilter) {
                $invalidValues[] = is_object($describeLayoutFeedViewFeedFiltersItem) ? get_class($describeLayoutFeedViewFeedFiltersItem) : sprintf('%s(%s)', gettype($describeLayoutFeedViewFeedFiltersItem), var_export($describeLayoutFeedViewFeedFiltersItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The feedFilters property can only contain items of type \AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedFilter, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set feedFilters value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedFilter[] $feedFilters
     * @return \AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedView
     */
    public function setFeedFilters(array $feedFilters = array())
    {
        // validation for constraint: array
        if ('' !== ($feedFiltersArrayErrorMessage = self::validateFeedFiltersForArrayConstraintsFromSetFeedFilters($feedFilters))) {
            throw new \InvalidArgumentException($feedFiltersArrayErrorMessage, __LINE__);
        }
        $this->feedFilters = $feedFilters;
        return $this;
    }
    /**
     * Add item to feedFilters value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedFilter $item
     * @return \AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedView
     */
    public function addToFeedFilters(\AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedFilter $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedFilter) {
            throw new \InvalidArgumentException(sprintf('The feedFilters property can only contain items of type \AfhcFacilityFinder\SForce\StructType\DescribeLayoutFeedFilter, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->feedFilters[] = $item;
        return $this;
    }
}
