<?php

namespace AfhcFacilityFinder\SForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DescribeQuickActionListResult StructType
 * @subpackage Structs
 */
class DescribeQuickActionListResult extends AbstractStructBase
{
    /**
     * The quickActionListItems
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \AfhcFacilityFinder\SForce\StructType\DescribeQuickActionListItemResult[]
     */
    public $quickActionListItems;
    /**
     * Constructor method for DescribeQuickActionListResult
     * @uses DescribeQuickActionListResult::setQuickActionListItems()
     * @param \AfhcFacilityFinder\SForce\StructType\DescribeQuickActionListItemResult[] $quickActionListItems
     */
    public function __construct(array $quickActionListItems = array())
    {
        $this
            ->setQuickActionListItems($quickActionListItems);
    }
    /**
     * Get quickActionListItems value
     * @return \AfhcFacilityFinder\SForce\StructType\DescribeQuickActionListItemResult[]|null
     */
    public function getQuickActionListItems()
    {
        return $this->quickActionListItems;
    }
    /**
     * This method is responsible for validating the values passed to the setQuickActionListItems method
     * This method is willingly generated in order to preserve the one-line inline validation within the setQuickActionListItems method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateQuickActionListItemsForArrayConstraintsFromSetQuickActionListItems(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $describeQuickActionListResultQuickActionListItemsItem) {
            // validation for constraint: itemType
            if (!$describeQuickActionListResultQuickActionListItemsItem instanceof \AfhcFacilityFinder\SForce\StructType\DescribeQuickActionListItemResult) {
                $invalidValues[] = is_object($describeQuickActionListResultQuickActionListItemsItem) ? get_class($describeQuickActionListResultQuickActionListItemsItem) : sprintf('%s(%s)', gettype($describeQuickActionListResultQuickActionListItemsItem), var_export($describeQuickActionListResultQuickActionListItemsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The quickActionListItems property can only contain items of type \AfhcFacilityFinder\SForce\StructType\DescribeQuickActionListItemResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set quickActionListItems value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\DescribeQuickActionListItemResult[] $quickActionListItems
     * @return \AfhcFacilityFinder\SForce\StructType\DescribeQuickActionListResult
     */
    public function setQuickActionListItems(array $quickActionListItems = array())
    {
        // validation for constraint: array
        if ('' !== ($quickActionListItemsArrayErrorMessage = self::validateQuickActionListItemsForArrayConstraintsFromSetQuickActionListItems($quickActionListItems))) {
            throw new \InvalidArgumentException($quickActionListItemsArrayErrorMessage, __LINE__);
        }
        $this->quickActionListItems = $quickActionListItems;
        return $this;
    }
    /**
     * Add item to quickActionListItems value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\DescribeQuickActionListItemResult $item
     * @return \AfhcFacilityFinder\SForce\StructType\DescribeQuickActionListResult
     */
    public function addToQuickActionListItems(\AfhcFacilityFinder\SForce\StructType\DescribeQuickActionListItemResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AfhcFacilityFinder\SForce\StructType\DescribeQuickActionListItemResult) {
            throw new \InvalidArgumentException(sprintf('The quickActionListItems property can only contain items of type \AfhcFacilityFinder\SForce\StructType\DescribeQuickActionListItemResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->quickActionListItems[] = $item;
        return $this;
    }
}
