<?php

namespace AfhcFacilityFinder\SForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LimitInfoHeader StructType
 * @subpackage Structs
 */
class LimitInfoHeader extends AbstractStructBase
{
    /**
     * The limitInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \AfhcFacilityFinder\SForce\StructType\LimitInfo[]
     */
    public $limitInfo;
    /**
     * Constructor method for LimitInfoHeader
     * @uses LimitInfoHeader::setLimitInfo()
     * @param \AfhcFacilityFinder\SForce\StructType\LimitInfo[] $limitInfo
     */
    public function __construct(array $limitInfo = array())
    {
        $this
            ->setLimitInfo($limitInfo);
    }
    /**
     * Get limitInfo value
     * @return \AfhcFacilityFinder\SForce\StructType\LimitInfo[]|null
     */
    public function getLimitInfo()
    {
        return $this->limitInfo;
    }
    /**
     * This method is responsible for validating the values passed to the setLimitInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setLimitInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateLimitInfoForArrayConstraintsFromSetLimitInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $limitInfoHeaderLimitInfoItem) {
            // validation for constraint: itemType
            if (!$limitInfoHeaderLimitInfoItem instanceof \AfhcFacilityFinder\SForce\StructType\LimitInfo) {
                $invalidValues[] = is_object($limitInfoHeaderLimitInfoItem) ? get_class($limitInfoHeaderLimitInfoItem) : sprintf('%s(%s)', gettype($limitInfoHeaderLimitInfoItem), var_export($limitInfoHeaderLimitInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The limitInfo property can only contain items of type \AfhcFacilityFinder\SForce\StructType\LimitInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set limitInfo value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\LimitInfo[] $limitInfo
     * @return \AfhcFacilityFinder\SForce\StructType\LimitInfoHeader
     */
    public function setLimitInfo(array $limitInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($limitInfoArrayErrorMessage = self::validateLimitInfoForArrayConstraintsFromSetLimitInfo($limitInfo))) {
            throw new \InvalidArgumentException($limitInfoArrayErrorMessage, __LINE__);
        }
        $this->limitInfo = $limitInfo;
        return $this;
    }
    /**
     * Add item to limitInfo value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\LimitInfo $item
     * @return \AfhcFacilityFinder\SForce\StructType\LimitInfoHeader
     */
    public function addToLimitInfo(\AfhcFacilityFinder\SForce\StructType\LimitInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AfhcFacilityFinder\SForce\StructType\LimitInfo) {
            throw new \InvalidArgumentException(sprintf('The limitInfo property can only contain items of type \AfhcFacilityFinder\SForce\StructType\LimitInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->limitInfo[] = $item;
        return $this;
    }
}
