<?php

namespace AfhcFacilityFinder\SForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListViewRecord StructType
 * @subpackage Structs
 */
class ListViewRecord extends AbstractStructBase
{
    /**
     * The columns
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \AfhcFacilityFinder\SForce\StructType\ListViewRecordColumn[]
     */
    public $columns;
    /**
     * Constructor method for ListViewRecord
     * @uses ListViewRecord::setColumns()
     * @param \AfhcFacilityFinder\SForce\StructType\ListViewRecordColumn[] $columns
     */
    public function __construct(array $columns = array())
    {
        $this
            ->setColumns($columns);
    }
    /**
     * Get columns value
     * @return \AfhcFacilityFinder\SForce\StructType\ListViewRecordColumn[]
     */
    public function getColumns()
    {
        return $this->columns;
    }
    /**
     * This method is responsible for validating the values passed to the setColumns method
     * This method is willingly generated in order to preserve the one-line inline validation within the setColumns method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateColumnsForArrayConstraintsFromSetColumns(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $listViewRecordColumnsItem) {
            // validation for constraint: itemType
            if (!$listViewRecordColumnsItem instanceof \AfhcFacilityFinder\SForce\StructType\ListViewRecordColumn) {
                $invalidValues[] = is_object($listViewRecordColumnsItem) ? get_class($listViewRecordColumnsItem) : sprintf('%s(%s)', gettype($listViewRecordColumnsItem), var_export($listViewRecordColumnsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The columns property can only contain items of type \AfhcFacilityFinder\SForce\StructType\ListViewRecordColumn, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set columns value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\ListViewRecordColumn[] $columns
     * @return \AfhcFacilityFinder\SForce\StructType\ListViewRecord
     */
    public function setColumns(array $columns = array())
    {
        // validation for constraint: array
        if ('' !== ($columnsArrayErrorMessage = self::validateColumnsForArrayConstraintsFromSetColumns($columns))) {
            throw new \InvalidArgumentException($columnsArrayErrorMessage, __LINE__);
        }
        $this->columns = $columns;
        return $this;
    }
    /**
     * Add item to columns value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\ListViewRecordColumn $item
     * @return \AfhcFacilityFinder\SForce\StructType\ListViewRecord
     */
    public function addToColumns(\AfhcFacilityFinder\SForce\StructType\ListViewRecordColumn $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AfhcFacilityFinder\SForce\StructType\ListViewRecordColumn) {
            throw new \InvalidArgumentException(sprintf('The columns property can only contain items of type \AfhcFacilityFinder\SForce\StructType\ListViewRecordColumn, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->columns[] = $item;
        return $this;
    }
}
