<?php

namespace AfhcFacilityFinder\SForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for merge StructType
 * @subpackage Structs
 */
class Merge extends AbstractStructBase
{
    /**
     * The request
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \AfhcFacilityFinder\SForce\StructType\MergeRequest[]
     */
    public $request;
    /**
     * Constructor method for merge
     * @uses Merge::setRequest()
     * @param \AfhcFacilityFinder\SForce\StructType\MergeRequest[] $request
     */
    public function __construct(array $request = array())
    {
        $this
            ->setRequest($request);
    }
    /**
     * Get request value
     * @return \AfhcFacilityFinder\SForce\StructType\MergeRequest[]|null
     */
    public function getRequest()
    {
        return $this->request;
    }
    /**
     * This method is responsible for validating the values passed to the setRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRequest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRequestForArrayConstraintsFromSetRequest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $mergeRequestItem) {
            // validation for constraint: itemType
            if (!$mergeRequestItem instanceof \AfhcFacilityFinder\SForce\StructType\MergeRequest) {
                $invalidValues[] = is_object($mergeRequestItem) ? get_class($mergeRequestItem) : sprintf('%s(%s)', gettype($mergeRequestItem), var_export($mergeRequestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The request property can only contain items of type \AfhcFacilityFinder\SForce\StructType\MergeRequest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set request value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\MergeRequest[] $request
     * @return \AfhcFacilityFinder\SForce\StructType\Merge
     */
    public function setRequest(array $request = array())
    {
        // validation for constraint: array
        if ('' !== ($requestArrayErrorMessage = self::validateRequestForArrayConstraintsFromSetRequest($request))) {
            throw new \InvalidArgumentException($requestArrayErrorMessage, __LINE__);
        }
        $this->request = $request;
        return $this;
    }
    /**
     * Add item to request value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\MergeRequest $item
     * @return \AfhcFacilityFinder\SForce\StructType\Merge
     */
    public function addToRequest(\AfhcFacilityFinder\SForce\StructType\MergeRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AfhcFacilityFinder\SForce\StructType\MergeRequest) {
            throw new \InvalidArgumentException(sprintf('The request property can only contain items of type \AfhcFacilityFinder\SForce\StructType\MergeRequest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->request[] = $item;
        return $this;
    }
}
