<?php

namespace AfhcFacilityFinder\SForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OwnerChangeOption StructType
 * @subpackage Structs
 */
class OwnerChangeOption extends AbstractStructBase
{
    /**
     * The type
     * @var string
     */
    public $type;
    /**
     * The execute
     * @var bool
     */
    public $execute;
    /**
     * Constructor method for OwnerChangeOption
     * @uses OwnerChangeOption::setType()
     * @uses OwnerChangeOption::setExecute()
     * @param string $type
     * @param bool $execute
     */
    public function __construct($type = null, $execute = null)
    {
        $this
            ->setType($type)
            ->setExecute($execute);
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @uses \AfhcFacilityFinder\SForce\EnumType\OwnerChangeOptionType::valueIsValid()
     * @uses \AfhcFacilityFinder\SForce\EnumType\OwnerChangeOptionType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \AfhcFacilityFinder\SForce\StructType\OwnerChangeOption
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\AfhcFacilityFinder\SForce\EnumType\OwnerChangeOptionType::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \AfhcFacilityFinder\SForce\EnumType\OwnerChangeOptionType', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \AfhcFacilityFinder\SForce\EnumType\OwnerChangeOptionType::getValidValues())), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get execute value
     * @return bool|null
     */
    public function getExecute()
    {
        return $this->execute;
    }
    /**
     * Set execute value
     * @param bool $execute
     * @return \AfhcFacilityFinder\SForce\StructType\OwnerChangeOption
     */
    public function setExecute($execute = null)
    {
        // validation for constraint: boolean
        if (!is_null($execute) && !is_bool($execute)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($execute, true), gettype($execute)), __LINE__);
        }
        $this->execute = $execute;
        return $this;
    }
}
