<?php

namespace AfhcFacilityFinder\SForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for performQuickActions StructType
 * @subpackage Structs
 */
class PerformQuickActions extends AbstractStructBase
{
    /**
     * The quickActions
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \AfhcFacilityFinder\SForce\StructType\PerformQuickActionRequest[]
     */
    public $quickActions;
    /**
     * Constructor method for performQuickActions
     * @uses PerformQuickActions::setQuickActions()
     * @param \AfhcFacilityFinder\SForce\StructType\PerformQuickActionRequest[] $quickActions
     */
    public function __construct(array $quickActions = array())
    {
        $this
            ->setQuickActions($quickActions);
    }
    /**
     * Get quickActions value
     * @return \AfhcFacilityFinder\SForce\StructType\PerformQuickActionRequest[]|null
     */
    public function getQuickActions()
    {
        return $this->quickActions;
    }
    /**
     * This method is responsible for validating the values passed to the setQuickActions method
     * This method is willingly generated in order to preserve the one-line inline validation within the setQuickActions method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateQuickActionsForArrayConstraintsFromSetQuickActions(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $performQuickActionsQuickActionsItem) {
            // validation for constraint: itemType
            if (!$performQuickActionsQuickActionsItem instanceof \AfhcFacilityFinder\SForce\StructType\PerformQuickActionRequest) {
                $invalidValues[] = is_object($performQuickActionsQuickActionsItem) ? get_class($performQuickActionsQuickActionsItem) : sprintf('%s(%s)', gettype($performQuickActionsQuickActionsItem), var_export($performQuickActionsQuickActionsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The quickActions property can only contain items of type \AfhcFacilityFinder\SForce\StructType\PerformQuickActionRequest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set quickActions value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\PerformQuickActionRequest[] $quickActions
     * @return \AfhcFacilityFinder\SForce\StructType\PerformQuickActions
     */
    public function setQuickActions(array $quickActions = array())
    {
        // validation for constraint: array
        if ('' !== ($quickActionsArrayErrorMessage = self::validateQuickActionsForArrayConstraintsFromSetQuickActions($quickActions))) {
            throw new \InvalidArgumentException($quickActionsArrayErrorMessage, __LINE__);
        }
        $this->quickActions = $quickActions;
        return $this;
    }
    /**
     * Add item to quickActions value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\PerformQuickActionRequest $item
     * @return \AfhcFacilityFinder\SForce\StructType\PerformQuickActions
     */
    public function addToQuickActions(\AfhcFacilityFinder\SForce\StructType\PerformQuickActionRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AfhcFacilityFinder\SForce\StructType\PerformQuickActionRequest) {
            throw new \InvalidArgumentException(sprintf('The quickActions property can only contain items of type \AfhcFacilityFinder\SForce\StructType\PerformQuickActionRequest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->quickActions[] = $item;
        return $this;
    }
}
