<?php

namespace AfhcFacilityFinder\SForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for process StructType
 * @subpackage Structs
 */
class Process extends AbstractStructBase
{
    /**
     * The actions
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \AfhcFacilityFinder\SForce\StructType\ProcessRequest[]
     */
    public $actions;
    /**
     * Constructor method for process
     * @uses Process::setActions()
     * @param \AfhcFacilityFinder\SForce\StructType\ProcessRequest[] $actions
     */
    public function __construct(array $actions = array())
    {
        $this
            ->setActions($actions);
    }
    /**
     * Get actions value
     * @return \AfhcFacilityFinder\SForce\StructType\ProcessRequest[]|null
     */
    public function getActions()
    {
        return $this->actions;
    }
    /**
     * This method is responsible for validating the values passed to the setActions method
     * This method is willingly generated in order to preserve the one-line inline validation within the setActions method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateActionsForArrayConstraintsFromSetActions(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $processActionsItem) {
            // validation for constraint: itemType
            if (!$processActionsItem instanceof \AfhcFacilityFinder\SForce\StructType\ProcessRequest) {
                $invalidValues[] = is_object($processActionsItem) ? get_class($processActionsItem) : sprintf('%s(%s)', gettype($processActionsItem), var_export($processActionsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The actions property can only contain items of type \AfhcFacilityFinder\SForce\StructType\ProcessRequest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set actions value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\ProcessRequest[] $actions
     * @return \AfhcFacilityFinder\SForce\StructType\Process
     */
    public function setActions(array $actions = array())
    {
        // validation for constraint: array
        if ('' !== ($actionsArrayErrorMessage = self::validateActionsForArrayConstraintsFromSetActions($actions))) {
            throw new \InvalidArgumentException($actionsArrayErrorMessage, __LINE__);
        }
        $this->actions = $actions;
        return $this;
    }
    /**
     * Add item to actions value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\ProcessRequest $item
     * @return \AfhcFacilityFinder\SForce\StructType\Process
     */
    public function addToActions(\AfhcFacilityFinder\SForce\StructType\ProcessRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AfhcFacilityFinder\SForce\StructType\ProcessRequest) {
            throw new \InvalidArgumentException(sprintf('The actions property can only contain items of type \AfhcFacilityFinder\SForce\StructType\ProcessRequest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->actions[] = $item;
        return $this;
    }
}
