<?php

namespace AfhcFacilityFinder\SForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for renderEmailTemplateResponse StructType
 * @subpackage Structs
 */
class RenderEmailTemplateResponse extends AbstractStructBase
{
    /**
     * The result
     * Meta information extracted from the WSDL
     * - maxOccurs: 10
     * - minOccurs: 0
     * @var \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult[]
     */
    public $result;
    /**
     * Constructor method for renderEmailTemplateResponse
     * @uses RenderEmailTemplateResponse::setResult()
     * @param \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult[] $result
     */
    public function __construct(array $result = array())
    {
        $this
            ->setResult($result);
    }
    /**
     * Get result value
     * @return \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult[]|null
     */
    public function getResult()
    {
        return $this->result;
    }
    /**
     * This method is responsible for validating the values passed to the setResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResultForArrayConstraintsFromSetResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $renderEmailTemplateResponseResultItem) {
            // validation for constraint: itemType
            if (!$renderEmailTemplateResponseResultItem instanceof \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult) {
                $invalidValues[] = is_object($renderEmailTemplateResponseResultItem) ? get_class($renderEmailTemplateResponseResultItem) : sprintf('%s(%s)', gettype($renderEmailTemplateResponseResultItem), var_export($renderEmailTemplateResponseResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The result property can only contain items of type \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set result value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult[] $result
     * @return \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResponse
     */
    public function setResult(array $result = array())
    {
        // validation for constraint: array
        if ('' !== ($resultArrayErrorMessage = self::validateResultForArrayConstraintsFromSetResult($result))) {
            throw new \InvalidArgumentException($resultArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(10)
        if (is_array($result) && count($result) > 10) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 10', count($result)), __LINE__);
        }
        $this->result = $result;
        return $this;
    }
    /**
     * Add item to result value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult $item
     * @return \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResponse
     */
    public function addToResult(\AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult) {
            throw new \InvalidArgumentException(sprintf('The result property can only contain items of type \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(10)
        if (is_array($this->result) && count($this->result) >= 10) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 10', count($this->result)), __LINE__);
        }
        $this->result[] = $item;
        return $this;
    }
}
