<?php

namespace AfhcFacilityFinder\SForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RenderEmailTemplateResult StructType
 * @subpackage Structs
 */
class RenderEmailTemplateResult extends AbstractStructBase
{
    /**
     * The bodyResults
     * Meta information extracted from the WSDL
     * - maxOccurs: 10
     * - minOccurs: 0
     * @var \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateBodyResult[]
     */
    public $bodyResults;
    /**
     * The errors
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \AfhcFacilityFinder\SForce\StructType\Error[]
     */
    public $errors;
    /**
     * The success
     * @var bool
     */
    public $success;
    /**
     * Constructor method for RenderEmailTemplateResult
     * @uses RenderEmailTemplateResult::setBodyResults()
     * @uses RenderEmailTemplateResult::setErrors()
     * @uses RenderEmailTemplateResult::setSuccess()
     * @param \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateBodyResult[] $bodyResults
     * @param \AfhcFacilityFinder\SForce\StructType\Error[] $errors
     * @param bool $success
     */
    public function __construct(array $bodyResults = array(), array $errors = array(), $success = null)
    {
        $this
            ->setBodyResults($bodyResults)
            ->setErrors($errors)
            ->setSuccess($success);
    }
    /**
     * Get bodyResults value
     * @return \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateBodyResult[]|null
     */
    public function getBodyResults()
    {
        return $this->bodyResults;
    }
    /**
     * This method is responsible for validating the values passed to the setBodyResults method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBodyResults method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBodyResultsForArrayConstraintsFromSetBodyResults(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $renderEmailTemplateResultBodyResultsItem) {
            // validation for constraint: itemType
            if (!$renderEmailTemplateResultBodyResultsItem instanceof \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateBodyResult) {
                $invalidValues[] = is_object($renderEmailTemplateResultBodyResultsItem) ? get_class($renderEmailTemplateResultBodyResultsItem) : sprintf('%s(%s)', gettype($renderEmailTemplateResultBodyResultsItem), var_export($renderEmailTemplateResultBodyResultsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The bodyResults property can only contain items of type \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateBodyResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set bodyResults value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateBodyResult[] $bodyResults
     * @return \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult
     */
    public function setBodyResults(array $bodyResults = array())
    {
        // validation for constraint: array
        if ('' !== ($bodyResultsArrayErrorMessage = self::validateBodyResultsForArrayConstraintsFromSetBodyResults($bodyResults))) {
            throw new \InvalidArgumentException($bodyResultsArrayErrorMessage, __LINE__);
        }
        // validation for constraint: maxOccurs(10)
        if (is_array($bodyResults) && count($bodyResults) > 10) {
            throw new \InvalidArgumentException(sprintf('Invalid count of %s, the number of elements contained by the property must be less than or equal to 10', count($bodyResults)), __LINE__);
        }
        $this->bodyResults = $bodyResults;
        return $this;
    }
    /**
     * Add item to bodyResults value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateBodyResult $item
     * @return \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult
     */
    public function addToBodyResults(\AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateBodyResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateBodyResult) {
            throw new \InvalidArgumentException(sprintf('The bodyResults property can only contain items of type \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateBodyResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: maxOccurs(10)
        if (is_array($this->bodyResults) && count($this->bodyResults) >= 10) {
            throw new \InvalidArgumentException(sprintf('You can\'t add anymore element to this property that already contains %s elements, the number of elements contained by the property must be less than or equal to 10', count($this->bodyResults)), __LINE__);
        }
        $this->bodyResults[] = $item;
        return $this;
    }
    /**
     * Get errors value
     * @return \AfhcFacilityFinder\SForce\StructType\Error[]|null
     */
    public function getErrors()
    {
        return $this->errors;
    }
    /**
     * This method is responsible for validating the values passed to the setErrors method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErrors method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErrorsForArrayConstraintsFromSetErrors(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $renderEmailTemplateResultErrorsItem) {
            // validation for constraint: itemType
            if (!$renderEmailTemplateResultErrorsItem instanceof \AfhcFacilityFinder\SForce\StructType\Error) {
                $invalidValues[] = is_object($renderEmailTemplateResultErrorsItem) ? get_class($renderEmailTemplateResultErrorsItem) : sprintf('%s(%s)', gettype($renderEmailTemplateResultErrorsItem), var_export($renderEmailTemplateResultErrorsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The errors property can only contain items of type \AfhcFacilityFinder\SForce\StructType\Error, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set errors value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\Error[] $errors
     * @return \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult
     */
    public function setErrors(array $errors = array())
    {
        // validation for constraint: array
        if ('' !== ($errorsArrayErrorMessage = self::validateErrorsForArrayConstraintsFromSetErrors($errors))) {
            throw new \InvalidArgumentException($errorsArrayErrorMessage, __LINE__);
        }
        $this->errors = $errors;
        return $this;
    }
    /**
     * Add item to errors value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\Error $item
     * @return \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult
     */
    public function addToErrors(\AfhcFacilityFinder\SForce\StructType\Error $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AfhcFacilityFinder\SForce\StructType\Error) {
            throw new \InvalidArgumentException(sprintf('The errors property can only contain items of type \AfhcFacilityFinder\SForce\StructType\Error, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->errors[] = $item;
        return $this;
    }
    /**
     * Get success value
     * @return bool|null
     */
    public function getSuccess()
    {
        return $this->success;
    }
    /**
     * Set success value
     * @param bool $success
     * @return \AfhcFacilityFinder\SForce\StructType\RenderEmailTemplateResult
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->success = $success;
        return $this;
    }
}
