<?php

namespace AfhcFacilityFinder\SForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SearchRecordMetadata StructType
 * @subpackage Structs
 */
class SearchRecordMetadata extends AbstractStructBase
{
    /**
     * The searchPromoted
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $searchPromoted;
    /**
     * The spellCorrected
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $spellCorrected;
    /**
     * Constructor method for SearchRecordMetadata
     * @uses SearchRecordMetadata::setSearchPromoted()
     * @uses SearchRecordMetadata::setSpellCorrected()
     * @param bool $searchPromoted
     * @param bool $spellCorrected
     */
    public function __construct($searchPromoted = null, $spellCorrected = null)
    {
        $this
            ->setSearchPromoted($searchPromoted)
            ->setSpellCorrected($spellCorrected);
    }
    /**
     * Get searchPromoted value
     * @return bool
     */
    public function getSearchPromoted()
    {
        return $this->searchPromoted;
    }
    /**
     * Set searchPromoted value
     * @param bool $searchPromoted
     * @return \AfhcFacilityFinder\SForce\StructType\SearchRecordMetadata
     */
    public function setSearchPromoted($searchPromoted = null)
    {
        // validation for constraint: boolean
        if (!is_null($searchPromoted) && !is_bool($searchPromoted)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($searchPromoted, true), gettype($searchPromoted)), __LINE__);
        }
        $this->searchPromoted = $searchPromoted;
        return $this;
    }
    /**
     * Get spellCorrected value
     * @return bool
     */
    public function getSpellCorrected()
    {
        return $this->spellCorrected;
    }
    /**
     * Set spellCorrected value
     * @param bool $spellCorrected
     * @return \AfhcFacilityFinder\SForce\StructType\SearchRecordMetadata
     */
    public function setSpellCorrected($spellCorrected = null)
    {
        // validation for constraint: boolean
        if (!is_null($spellCorrected) && !is_bool($spellCorrected)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($spellCorrected, true), gettype($spellCorrected)), __LINE__);
        }
        $this->spellCorrected = $spellCorrected;
        return $this;
    }
}
