<?php

namespace AfhcFacilityFinder\SForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendEmailResult StructType
 * @subpackage Structs
 */
class SendEmailResult extends AbstractStructBase
{
    /**
     * The errors
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \AfhcFacilityFinder\SForce\StructType\SendEmailError[]
     */
    public $errors;
    /**
     * The success
     * @var bool
     */
    public $success;
    /**
     * Constructor method for SendEmailResult
     * @uses SendEmailResult::setErrors()
     * @uses SendEmailResult::setSuccess()
     * @param \AfhcFacilityFinder\SForce\StructType\SendEmailError[] $errors
     * @param bool $success
     */
    public function __construct(array $errors = array(), $success = null)
    {
        $this
            ->setErrors($errors)
            ->setSuccess($success);
    }
    /**
     * Get errors value
     * @return \AfhcFacilityFinder\SForce\StructType\SendEmailError[]|null
     */
    public function getErrors()
    {
        return $this->errors;
    }
    /**
     * This method is responsible for validating the values passed to the setErrors method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErrors method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErrorsForArrayConstraintsFromSetErrors(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $sendEmailResultErrorsItem) {
            // validation for constraint: itemType
            if (!$sendEmailResultErrorsItem instanceof \AfhcFacilityFinder\SForce\StructType\SendEmailError) {
                $invalidValues[] = is_object($sendEmailResultErrorsItem) ? get_class($sendEmailResultErrorsItem) : sprintf('%s(%s)', gettype($sendEmailResultErrorsItem), var_export($sendEmailResultErrorsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The errors property can only contain items of type \AfhcFacilityFinder\SForce\StructType\SendEmailError, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set errors value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\SendEmailError[] $errors
     * @return \AfhcFacilityFinder\SForce\StructType\SendEmailResult
     */
    public function setErrors(array $errors = array())
    {
        // validation for constraint: array
        if ('' !== ($errorsArrayErrorMessage = self::validateErrorsForArrayConstraintsFromSetErrors($errors))) {
            throw new \InvalidArgumentException($errorsArrayErrorMessage, __LINE__);
        }
        $this->errors = $errors;
        return $this;
    }
    /**
     * Add item to errors value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\SendEmailError $item
     * @return \AfhcFacilityFinder\SForce\StructType\SendEmailResult
     */
    public function addToErrors(\AfhcFacilityFinder\SForce\StructType\SendEmailError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AfhcFacilityFinder\SForce\StructType\SendEmailError) {
            throw new \InvalidArgumentException(sprintf('The errors property can only contain items of type \AfhcFacilityFinder\SForce\StructType\SendEmailError, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->errors[] = $item;
        return $this;
    }
    /**
     * Get success value
     * @return bool|null
     */
    public function getSuccess()
    {
        return $this->success;
    }
    /**
     * Set success value
     * @param bool $success
     * @return \AfhcFacilityFinder\SForce\StructType\SendEmailResult
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->success = $success;
        return $this;
    }
}
