<?php

namespace AfhcFacilityFinder\SForce\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for undeleteResponse StructType
 * @subpackage Structs
 */
class UndeleteResponse extends AbstractStructBase
{
    /**
     * The result
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \AfhcFacilityFinder\SForce\StructType\UndeleteResult[]
     */
    public $result;
    /**
     * Constructor method for undeleteResponse
     * @uses UndeleteResponse::setResult()
     * @param \AfhcFacilityFinder\SForce\StructType\UndeleteResult[] $result
     */
    public function __construct(array $result = array())
    {
        $this
            ->setResult($result);
    }
    /**
     * Get result value
     * @return \AfhcFacilityFinder\SForce\StructType\UndeleteResult[]
     */
    public function getResult()
    {
        return $this->result;
    }
    /**
     * This method is responsible for validating the values passed to the setResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResultForArrayConstraintsFromSetResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $undeleteResponseResultItem) {
            // validation for constraint: itemType
            if (!$undeleteResponseResultItem instanceof \AfhcFacilityFinder\SForce\StructType\UndeleteResult) {
                $invalidValues[] = is_object($undeleteResponseResultItem) ? get_class($undeleteResponseResultItem) : sprintf('%s(%s)', gettype($undeleteResponseResultItem), var_export($undeleteResponseResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The result property can only contain items of type \AfhcFacilityFinder\SForce\StructType\UndeleteResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set result value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\UndeleteResult[] $result
     * @return \AfhcFacilityFinder\SForce\StructType\UndeleteResponse
     */
    public function setResult(array $result = array())
    {
        // validation for constraint: array
        if ('' !== ($resultArrayErrorMessage = self::validateResultForArrayConstraintsFromSetResult($result))) {
            throw new \InvalidArgumentException($resultArrayErrorMessage, __LINE__);
        }
        $this->result = $result;
        return $this;
    }
    /**
     * Add item to result value
     * @throws \InvalidArgumentException
     * @param \AfhcFacilityFinder\SForce\StructType\UndeleteResult $item
     * @return \AfhcFacilityFinder\SForce\StructType\UndeleteResponse
     */
    public function addToResult(\AfhcFacilityFinder\SForce\StructType\UndeleteResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \AfhcFacilityFinder\SForce\StructType\UndeleteResult) {
            throw new \InvalidArgumentException(sprintf('The result property can only contain items of type \AfhcFacilityFinder\SForce\StructType\UndeleteResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->result[] = $item;
        return $this;
    }
}
